#include <thread>
#include <iostream>
#include <cstdlib>		//atoi()
#include "UniSocket.hpp"
using namespace std;

// Achtung: Blockierendes lesen!
// thread beendet sich nicht, wenn keine Daten empfangen werden.
void threadHandle(UniSocket usock) {
	string msg = usock.recv();
	cout << "client "<< usock.getIp() << " sagt: " << msg << endl;
	usock.send("Hallo "+ usock.getIp() + ". Warum " + msg + "?");
	usock.close();
}

int main(int argc, char * argv[]) {
	if (argc < 2) {
		cout<<"usage: "<<argv[0]<<" <port>"<<endl;
		return 1;
	}
	try {
		UniServerSocket svr(atoi(argv[1]), 5, "[ENDE]");
		while (1) {
			thread t(threadHandle, svr.accept());
			t.detach();
		}
	} catch(UniSocketException e) {
		cout << e._msg << endl;
	}
	return 0;
}
